#pragma once
#include <Windows.h>
#include "common.h"
#include "usrerr.h"

#ifdef NETTUNNELSDK_EXPORTS
#define SCCSDK_API __declspec(dllexport)
#else
#define SCCSDK_API __declspec(dllimport)
#endif

typedef void (*PTUNNEL_HEART_ROUTINE)(const CHAR  *pMessage, unsigned int timeStampOfSeconds);
typedef PTUNNEL_HEART_ROUTINE LPTUNNEL_HEART_ROUTINE;

/** 
 *
 * @brief ؼϢ
 */
typedef struct {
    int                InterfaceIndex;                   ///< 
    NET_CONNECT_STATUS netConnStatus;                    ///< ״̬ @see NET_CONNECT_STATUS
    CHAR               NetCardUUID[260];                 ///< ƣ WindowsʶΪ UUID
    CHAR               NetCardName[MAX_NETCARD_NAME];    ///< 
    CHAR               NetCardDescription[132];          ///< 
    CHAR               NetCardIpaddr[MAX_IP_LEN];        ///<  IP ַ
    CHAR               NetCardNetmask[MAX_IP_LEN];       ///< 
    CHAR               NetCardGateway[MAX_IP_LEN];       ///< 
    CHAR               NetCardMacAddr[20];               ///<  MAC ַ
} NIC_CONTENT, *PNIC_CONTENT;

#ifdef __cplusplus    // If used by C++ code,
extern "C" {
// we need to export the C interface
#endif

/**
 * @brief ʼ SDK л
 * @param[in] pWorkDir  ·ϵͳԶȡ
 * @param[in] pSvrUrl ƽ̨ URL ַ example: http://localhost:2313, https://localhost:2313
 * @param[in] pLogFile  ־ļ/·
 * @param[in] level     ־Чȼ
 * @param[in] isWorkServer  SDK ģʽ
 * - TRUE 
 * - FALSE ͻ
 * @return ִн 0: ɹ С0 ʧ @see USER_ERRNO 
 * - -ERR_ITEM_EXISTS δҵ WireGuard 
 * - -ERR_SYS_CALL ȡñļ洢Ŀ¼ʧ
 * - -ERR_CREATE_FILE ûļĿ¼ʧ
 * - -ERR_ITEM_UNEXISTS WireGuard δװ
 * - ERR_SUCCESS ɹ
 */
SCCSDK_API int __cdecl TunnelSDKInitEnv(const CHAR  *pWorkDir,
                                        const CHAR  *pSvrUrl,
                                        const CHAR  *pLogFile,
                                        LOG_LEVEL    level,
                                        bool         isWorkServer);

/**
 * @brief  SDK Դ
 */
SCCSDK_API void __cdecl TunnelSDKUnInit();

/**
 * @brief /ر SDK ־
 * @param enLog ־
 * - TRUE   ־
 * - FALSE  ر־
 */
SCCSDK_API void __cdecl TunnelLogEnable(bool enLog);

/**
 * @brief ȡǰ WireGuard Ƿ
 * @param pTunnelName 
 * @param pIsRunning pIsRunning WireGuard ״̬
 * - TRUE Ѿװ
 * - FALSE δװ
 * @return ִн 0: ɹ С0 ʧ @see USER_ERRNO
 * - -ERR_INPUT_PARAMS 
 * - -ERR_OPEN_SCM 򿪷豸ʧ
 * - ERR_SUCCESS ɹ
 */
SCCSDK_API int __cdecl GetWireGuardServiceStatus(const CHAR  *pTunnelName, bool *pIsRunning);

/**
 * @brief жϵǰģʽ ͻ/
 * @param[out] pIsWorkServer ģʽ
 * - TRUE 
 * - FALSE ͻ
 * @return ִн 0: ɹ С0 ʧ @see USER_ERRNO
 * - -ERR_INPUT_PARAMS 
 * - ERR_SUCCESS ɹ
 */
SCCSDK_API int __cdecl GetWireGuardWorkMode(bool *pIsWorkServer);

/**
 * @brief ȡǰ WireGuard Ƿ
 * @param[in] pIfName WireGuard ӿ
 * @param[out] pIsRunning WireGuard ״̬
 * - TRUE Ѿװ
 * - FALSE δװ
 * @return 0: ɹ С0 ʧ @see USER_ERRNO
 * - -ERR_INPUT_PARAMS 
 * - -ERR_MALLOC_MEMORY ڴʧ
 * - ERR_SUCCESS ɹ
 */
SCCSDK_API int __cdecl IsWireGuardServerRunning(const CHAR  *pIfName, bool *pIsRunning);

/**
 * @brief SCG 񿪹
 * @param isEnable TRUE:  SCG , FALSE:  SCG 
 * @param pSCGIpAddr SCG  IP
 * @param scgPort SCG ˿
 * @return 0: ɹ С0 ʧ @see USER_ERRNO
 * - -ERR_INPUT_PARAMS  
 * - ERR_SUCCESS ɹ
 */
SCCSDK_API int __cdecl EnableSCGProxy(bool isEnable, const CHAR  *pSCGIpAddr, int scgPort);

/**
 * @brief ȡǰ SCG ״̬
 * @return TRUE: SCG , FALSE: SCG 
 */
SCCSDK_API bool __cdecl UsedSCGProxy();

/**
 * @brief ȡǰ繲ģʽ
 * @return ǰ繲ģʽ @see NET_SHARE_MODE
 */
SCCSDK_API NET_SHARE_MODE __cdecl GetCurrentNetShareMode();

/**
 * @brief ûȡǰ繲ģʽ
 * @param shareMode 繲ģʽ @see NET_SHARE_MODE
 */
SCCSDK_API void __cdecl SetCurrentNetShareMode(NET_SHARE_MODE shareMode);

/**
 * @brief ȡϢ
 * @param[out] pInfo Ϣ @see NIC_CONTENT
 * @param[out] pItemCounts ǰϵͳ ֵ 32
 * @return ִн 0: ɹ С0 ʧ @see USER_ERRNO
 * - -ERR_INPUT_PARAMS 
 * - -ERR_MALLOC_MEMORY ڴʧ
 * - ERR_SUCCESS ɹ
 */
SCCSDK_API int __cdecl GetAllNICInfo(PNIC_CONTENT *pInfo, int *pItemCounts);

/**
 * @brief ȡǰ Internet 
 * @param[out] pIfIndex 
 * @return ִн 0: ɹ С0 ʧ @see USER_ERRNO
 * - -ERR_INPUT_PARAMS 
 * - -ERR_ITEM_UNEXISTS δҵ Internet ӵ
 * - ERR_SUCCESS ɹ
 */
SCCSDK_API int __cdecl GetInternetIfIndex(int *pIfIndex);

/**
 * @brief жϵǰǷӵ Internet 
 * @param[in] ifIndex 
 * @param[in] pRet 
 * - TRUE  Internet 
 * - FALSE  Internet 
 * @return ִн 0: ɹ С0 ʧ @see USER_ERRNO
 * - -ERR_INPUT_PARAMS 
 * - -ERR_GET_IPFOWARDTBL ȡǽϢʧ
 * - ERR_SUCCESS ɹ
 */
SCCSDK_API int __cdecl IsInternetConnectAdapter(int ifIndex, bool *pRet);

/**
 * @brief ƽ̨ӿǩ֤
 * @param pClientId ͻ ID
 * @param pClientSecret ͻԿ
 * @return  ִн 0: ɹ С0 ʧ @see USER_ERRNO
 * - -ERR_INPUT_PARAMS 
 * - ERR_SUCCESS ɹ 
 */
SCCSDK_API int __cdecl EnableVerifySignature(const CHAR  *pClientId, const CHAR  *pClientSecret);

/**
 * @brief رƽ̨ӿǩ֤
 */
SCCSDK_API void __cdecl DisableVerifySignature();

/**
 * @brief ƵԷ˴Ʒ
 * @param pSvr Ϣ
 * @return 0: ɹ С0 ʧ @see USER_ERRNO
 * - -ERR_INPUT_PARAMS 
 * - -ERR_CREATE_THREAD ߳ʧ
 * - -ERR_SOCKET_BIND_PORT 󶨶˿ʧ
 * - -ERR_ITEM_EXISTS ߳״̬쳣
 * - ERR_SUCCESS ɹ
 */
SCCSDK_API int __cdecl CreateControlService(PUSER_SERVER_CONFIG pSvr);

/**
 * @brief ȡûϢ
 * @param[in] pUserName û
 * @param[in] pToken û
 * @param[out] pSvrCfg ûϢ
 * @return 0: ɹ С0 ʧ @see USER_ERRNO
 * - -ERR_INPUT_PARAMS 
 * - -ERR_MEMORY_STR ַ
 * - -ERR_CREATE_FILE ûĿ¼ʧ
 * - ERR_SUCCESS ɹ
 */
SCCSDK_API int __cdecl GetUserServerConfigure(const CHAR          *pUserName,
                                              const CHAR          *pToken,
                                              PUSER_SERVER_CONFIG *pSvrCfg);

/**
 * @brief ȡûͻϢ
 * @param[in] pUserName û
 * @param[in] pToken û
 * @param[out] pCliCfg ͻûϢ
 * @return 0: ɹ С0 ʧ @see USER_ERRNO
 * - -ERR_INPUT_PARAMS 
 * - -ERR_MEMORY_STR ַ
 * - -ERR_CREATE_FILE ûĿ¼ʧ
 * - ERR_SUCCESS ɹ
 */
SCCSDK_API int __cdecl GetUserClientConfigure(const CHAR          *pUserName,
                                              const CHAR          *pToken,
                                              PUSER_CLIENT_CONFIG *pCliCfg);

/**
 * @brief ֹͣƵԷ˷
 * @return 0: ɹ С0 ʧ @see USER_ERRNO
 * - -ERROR_TIMEOUT ȴʱ
 * - ERR_SUCCESS ɹ
 */
SCCSDK_API int __cdecl StopControlService();

/**
 * @brief Զ̿Ʒ
 * @param[in] vmId ҪӵID 
 * @param[in] pCliNetwork Ҫıַ
 * @return ɹ С0 ʧ @see USER_ERRNO
 * - -ERR_INPUT_PARAMS 
 * - -ERR_SYSTEM_UNINITIALIZE ˲δʼ
 * - -ERR_MALLOC_MEMORY ڴʧ
 * - -ERR_OPEN_FILE ļʧ
 * - -ERR_MEMORY_STR ַʧ
 * - -ERR_UN_SUPPORT ֵ֧ĸʽת
 * - -ERR_JSON_CREATE  JSON ַʧ
 * - -ERR_HTTP_POST_DATA  POST ʧ
 * - -ERR_HTTP_SERVER_RSP ˷ʧܣ200
 * - -ERR_READ_FILE ˷ؿ
 * - -ERR_JSON_DECODE  JSON ʧ 
 * - ERR_SUCCESS ɹ
 */
SCCSDK_API int __cdecl RemoteCtrlSvrCfgUserTunnel(int vmId, const CHAR  *pCliNetwork);

/**
 * @brief /ֹͣԶƵе WireGuard 
 * @param[in] isStart /ֹͣ TRUE , FALSE ֹͣ
 * @return 0: ɹ С0 ʧ @see USER_ERRNO
 * - -ERR_INPUT_PARAMS 
 * - -ERR_SYSTEM_UNINITIALIZE δʼԶ̷ URL ַ
 * - -ERR_CREATE_FILE ûĿ¼ʧ
 * - -ERR_HTTP_POST_DATA POST ݵʧ
 * - -ERR_HTTP_SERVER_RSP HTTP ش
 * - -ERR_READ_FILE δȷϢ
 * - -ERR_JSON_DECODE JSON ַʧ
 * - ERR_SUCCESS ɹ
 */
SCCSDK_API int __cdecl RemoteWireGuardControl(bool isStart);

/**
 * @brief /ֹͣ  WireGuard 
 * @param[in] isStart /ֹͣ TRUE , FALSE ֹͣ
 * @param[in] setPrivateMode ǷģʽΪ רģʽ(Private)
 * @return 0: ɹ С0 ʧ @see USER_ERRNO
 * - -ERR_INPUT_PARAMS 
 * - -ERR_NET_CATEGORY_MODE ģʽ
 * - -ERR_UN_SUPPORT ֵ֧繲
 * - ERR_SUCCESS ɹ
 */
SCCSDK_API int __cdecl LocalWireGuardControl(bool isStart, bool setPrivateMode);

/**
 * @brief /ֹͣ Ʒ
 * @param isStart /ֹͣ TRUE , FALSE ֹͣ
 * @param lpHeartCbAddress ص @see PTUNNEL_HEART_ROUTINE
 * @return 0: ɹ С0 ʧ @see USER_ERRNO
 * - -ERR_INPUT_PARAMS 
 * - -ERR_CREATE_TIMER ʱʧ
 * - -ERR_DELETE_TIMER ɾʱʧ
 * - ERR_SUCCESS ɹ
 */
SCCSDK_API int __cdecl RemoteHeartControl(bool isStart, LPTUNNEL_HEART_ROUTINE lpHeartCbAddress);

/**
 * @brief ȡûַ
 * @param err û
 * @return ûӦַ, "UNKNOWN": δ֪
 */
SCCSDK_API const CHAR* __cdecl GetSDKErrorMessage(USER_ERRNO err);
#ifdef __cplusplus
}
#endif
